Rem --- eWON start section: Cyclic Section
eWON_cyclic_section:
Rem --- eWON user (start)

Rem --- eWON user (end)
End
Rem --- eWON end section: Cyclic Section
Rem --- eWON start section: Init Section
eWON_init_section:
Rem --- eWON user (start)
//Set Line Parameters
line_rate = 100//BPM
///Time Stamp for 1st shift start
H1 = 6
M = 50
//POI1s1$ = "eocasio@msiexpress.com"
//Time Stamp for 2nd shift start
H2 = 14
//POI1s2$= "sallen@msiexpress.com"
//Time Stamp for 3rd shift start
H3 = 22
//POI1s3$=""
//check timer is on
timer = 0
//Number of seconds that have elapsed up to 30
counter = 0
// Declares variablt to check if it is the weekend
Weekend = 0
//Variables used for averages and other calculations.
sumPPM = 0
sumRej = 0
sumCheck = 0
DIM PPM15(30)
DIM REJ15(30)
DIM CHECK15(30)
ONDATE 1,"50 6 * * *","@Clear_Data"
ONDATE 2,"17 16 * * *","@Clear_Data"
ONDATE 3,"50 22 * * *","@Clear_Data"
ONDATE 4,"50 6 * * 6","Weekend = 1"
ONDATE 4,"50 6 * * 1","Weekend = 0"
//If a timer is not started, take an intial value and start a timer
Function Runtime()
If (timer = 0) Then
  ccheck1= Checkweigher_Infeed@
  creject1= Checkweigher_Reject@
  timer = 1
Endif
//Number of Bottles past the Checkweigher
Finished_Containers@ = Checkweigher_Infeed@-Checkweigher_Reject@
//Reject Percentage across shift
If Checkweigher_Infeed@ >0 Then
  Reject_Percentage_Long@ = Checkweigher_Reject@/Checkweigher_Infeed@*100 
Else 
  Reject_Percentage_Long@ = 0
Endif

@Line_Status()
Endfn
//If timer has elapsed then take a final value, use to compute change over time
Function Cycle_Average()
//@Pace_Check()
If (TGET 1) Then
  ccheckdif= (Checkweigher_Infeed@-ccheck1)
  crejectdif= (Checkweigher_Reject@-creject1)
  PPM@ = 2 * ccheckdif
  For $i%=30 To 1 Step -1
    If ($i% > 1) Then
      PPM15($i%) = PPM15($i%-1)
      REJ15($i%) = REJ15($i%-1)
      CHECK15($i%) = CHECK15($i%-1)
      sumPPM = sumPPM +PPM15($i%-1)
      sumRej = sumRej +REJ15($i%-1)
      sumCheck = sumCheck +CHECK15($i%-1)
    Else 
      PPM15($i%) = PPM@
      sumPPM = PPM@
      REJ15($i%) = crejectdif
      sumRej = sumRej +crejectdif
      CHECK15($i%) = ccheckdif
      sumCheck = sumcheck +ccheckdif
    Endif
  Next $i%
  If (counter<30) Then
    counter = counter + 1
  Endif
  Moving_Average_PPM@ = sumPPM/counter
  If sumCheck >0 Then
  Reject_Percentage_Short@ = sumRej/sumCheck*100
  Else
  Reject_Percentage_Short@ = 0
  Endif
  timer = 0
  sumPPM = 0
  sumRej = 0
  sumCheck = 0
Endif
Endfn
//Clears all data between shifts
Function Clear_Data()
//Commands counters to be set to 0 through modbus tag
Clear_Counter_Checkweigher_Reject@ = 1
Clear_Counter_Checkweigher_Infeed@ = 1
Pace_Throughput@ = 0
//resets all averages
For $j% =1 To 30 Step 1
REJ15($j%) = 0
CHECK15($j%) = 0
Next $j%

Print 1
Endfn
TSET 1, 30
Ontimer 1, "@Cycle_Average()"
TSET 2, 1
Ontimer 2, "@Runtime()"
//ONALARM "Cycle_Run", "@Alarm_Notify(1)"
//ONALARM "Cups_Per_Minute", "@Alarm_Notify(2)"
Function Line_Status()
If Cycle_Run@ = 1 Then
  Line_Status_Int@= 5
  Line_Status@ = "Line Running"
  If PPM@ < 75 Then
    Line_Status_Int@ = 4
    Line_Status@ = "Line Running Slowly"
  ENDIF
Else
  Line_Status@="Filler Off"
  Line_Status_Int@=3
  Endif
ENDIF
Endfn
Function Pace_Check()
T_Check$ = Time$
Hour% = Val(T_Check$(12 To 13))
Minute% = Val(T_Check$(15 To 16))
Pace_Time_slot = 0
If Hour% >= 7 And (Hour%<15) Then
  Pace_Time_Slot = 1
Else
  If Hour% >= 15 And Hour%<23 Then
    Pace_Time_Slot =2
  Else 
    Pace_Time_Slot = 3
  Endif
Endif
If Pace_Time_Slot = 1 Then
  Pace_Throughput@ = (Hour% - 7) * 60 * line_rate + Minute% * line_rate
Endif
If Pace_Time_Slot = 2 Then
  Pace_Throughput@ = (Hour% - 15) * 60 * line_rate + Minute% * line_rate
Endif
If Pace_Time_Slot = 3 Then
  If Hour% >20 Then
    Pace_Throughput@ = (Hour% - 22) * 60 * line_rate + Minute% * line_rate
  Else
    Pace_Throughput@ = Hour% * 60 * line_rate + Minute% * line_rate + 60 * line_rate
  Endif
Endif
If Finished_Containers@>0 Then
  If Pace_Throughput@/Finished_Containers@ <.7 Then
	  Pace_Color@ = 4
  Endif
  If Pace_Throughput@/Finished_Containers@ <1.2 Then
	  Pace_Color@ = 1
  Else 
    Pace_Color@ = 5
  Endif
Endif
Endfn
Rem --- eWON user (end)
End
Rem --- eWON end section: Init Section
